/*******************************************************************************
;
;  Codi d'Exemple per la utilitzaci de l'AD del 196KD
;
******************************************************************************/

#include        <kd_sfrs.h>

/******************************************************************************
;
;  Declaraci de Variables Globals
;
;******************************************************************************/

	int regtemp; // Para aplicar mscaras. 16 bits
	
	unsigned int  wConversio;
	unsigned char bADEnCurs;

/*  
  bADEnCurs s un flag que ens diu si el conversor est funcionant o no. 
  wConversio s on guardem el resultat de la conversi.

  Cal recordar que el valor convertit no es directament el resultat del 
  registre ad_result
  Es poden fer servir ms variables si es necessari.
*/


/******************************************************************************
;
;  Programa Principal
;
;******************************************************************************/

void main()
{

/*Inicialitzacions*/
	
	wsr=0;
	ioport1=0xAA; //Empezamos mostrando 1010 1010 en los leds
	
	wConversio=0xAA;
	bADEnCurs=1; // Empezamos convirtiendo

/*  Inicialitzem el registre de mscara posant un 1 a les interrupcions que volem 
    habilitar.*/

	asm { di; }
	wsr=0;	//Aunque podemos usar cualquier ventana para int_mask/int_mask1
	
	int_mask=int_mask | 0x82; //Habilitamos EXT_INT & AD Conversion complete
	                          //     1      x    x   x     x     1   x
	                          // ext_int|serial|swt|hsi0|hsidat|ad|t1ovf
							  //
	int_mask1=int_mask1 & 0xDF; // Desactivamos la INT13
  
	wsr=0xf; regtemp=ioc1;
	regtemp = regtemp & 0xFD; // Elegir pin p2.2
	wsr=0x0; ioc1=regtemp;
 
/*  Modifiquem el registre IOC2, seleccionem les opcions del conversor.*/
	wsr=0xf; regtemp=ioc2;
	regtemp = regtemp & 0xF7; // AD_TIME_ENA=0 para modo compatible con 196KB
	wsr=0x0; ioc2=regtemp;
	
	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x10; // 8 bits
	regtemp = regtemp & 0xF8; // Elegir puerto 0
	wsr=0x0; ad_command=regtemp;

/*  Finalment cal habilitar les interrupcions per poder servir-les. */
	asm { ei;}
                          

/*******************************************************************************
;
;  Una possibilitat es que el bucle principal pregunti si est el conversor ocupat, 
;  si no ho est lleni una conversi, activi el flag i es quedi esperant que acabi. 
;
;  Quan el conversor acabi la conversi generar una interrupci de Conversi Finalitzada 
;  i sigui la rutina de servei a la interrupci RSIADDone qui baixi el flag.
;
;  Caldria fer la lectura del resultat del registre ad_result, i mostrar-lo pel port1
;
;******************************************************************************/

	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x08; // GO=1
	wsr=0x0; ad_command=regtemp;

/*  Bucle del programa principal  */
/* Este bucle espera a que se haya acabado la interrupcin que lee el contenido del
   registro de resultado del conversor AD (rutina RSIADDone). Una vez acabada se
   muestra el resultado por el array de leds de la placa placa */
	
	while(1)
	{
////	wsr=0x0; ioport1=0xFF; // CHIVATO. QUITAR
	/* Estos chivatos se quitan en la versin de produccin. Hemos descubierto
	 tcnicas de debugging ms efectivas, tales como examinar los ficheros que
	 se generan al compilar el proyecto (.lst & .m96) y usar el debug monitor
	 con los valores que hemos obtenido de dichos ficheros.*/
	
	wsr=0x0; // Para leer ad_result
      	while (ad_result&0x08); // Esperar a que haya acabado (encuesta)


// while (1) {ioport1=bADEnCurs;} // probando



	wsr=0x00;
	////  ioport1=0xB1; // CHIVATO. QUITAR
	if (bADEnCurs) ioport1=wConversio;
	//// ioport1=0xCA; // CHIVATO. QUITAR

 	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x08; // GO=1
	wsr=0x0; ad_command=regtemp;

		
	}
}

/* 
  Recordeu de programar al fitxer stad.a96 les adresses de les rutines de servei
  a les interrupcions.
*/

/*******************************************************************************
;
;  Rutina de servei a la Interrupci Externa
;
;******************************************************************************/

void RSIExtInt()
{
/* Si recibimos una interrupcin de la RSI ExtInt, se bloquea el proceso de conversin
 * del AD, mostrando el ltimo valor convertido por este. Si volvemos a pulsar el botn
 * (que activa la INT07), podremos continuar viendo la conversin analgica en la ristra
 * de leds en tiempo real.*/
	asm {di;}
	bADEnCurs=!bADEnCurs;
	asm {ei;}
}
 
/*******************************************************************************
;
;  Rutina de servei a la interrupci d'AD conversion complete.
;
;******************************************************************************/

void RSIADDone()
{
/* Esta subrutina lee el resultado de la conversin del AD y la deja en la
 * variable wConversio, para ser procesada en el bucle principal. Tamben se
 * actualiza el estado del conversor AD mediante la variable ad_result que se
 * usa en el bucle principal. */
	
	asm {di;}
	
	wsr=0x0; regtemp=ad_result;
	wConversio=regtemp>>8;
	regtemp = regtemp & 0xF7; // Desactivar el bit de aviso
	wsr=0xf; ad_result=regtemp;
  
	asm {ei;}
}
