/******************************************************************************
;
;  Codi d'Exemple per la utilitzaci del LCD
;
;******************************************************************************/

#include <kd_sfrs.h>
#include <lcd.h>

/******************************************************************************
;
;  Programa Principal
;
;******************************************************************************/
int regtemp; // Para aplicar mscaras. 16 bits
	
unsigned int  wConversio;
unsigned char bADEnCurs;

  unsigned int porcent;


void main()
{
  unsigned char bData;  
  unsigned char missatge[10]="SDMI jarl";
  unsigned char i=0;


/*Inicialitzacions*/
	
	wsr=0;
	ioport1=0xAA; //Empezamos mostrando 1010 1010 en los leds
	
	wConversio=0xAA;
	bADEnCurs=1; // Empezamos convirtiendo

/*  Inicialitzem el registre de mscara posant un 1 a les interrupcions que volem 
    habilitar.*/

	INICIALITZA_LCD();
	
	asm { di; }
	wsr=0;	//Aunque podemos usar cualquier ventana para int_mask/int_mask1
	
	int_mask=int_mask | 0x02; //Habilitamos AD Conversion complete  (no el de EXT_INT)
	//int_mask=int_mask | 0x82; //Habilitamos EXT_INT & AD Conversion complete
	                          //     1      x    x   x     x     1   x
	                          // ext_int|serial|swt|hsi0|hsidat|ad|t1ovf
							  //
	int_mask1=int_mask1 & 0xDF; // Desactivamos la INT13
  
	wsr=0xf; regtemp=ioc1;
	regtemp = regtemp & 0xFD; // Elegir pin p2.2
	wsr=0x0; ioc1=regtemp;
 
/*  Modifiquem el registre IOC2, seleccionem les opcions del conversor.*/
	wsr=0xf; regtemp=ioc2;
	regtemp = regtemp & 0xF7; // AD_TIME_ENA=0 para modo compatible con 196KB
	wsr=0x0; ioc2=regtemp;
	
	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x10; // 8 bits
	regtemp = regtemp & 0xF8; // Elegir puerto 0
	wsr=0x0; ad_command=regtemp;


	
/*  Finalment cal habilitar les interrupcions per poder servir-les. */
	asm { ei;}
                          
     	CLRSCR_LCD();
	GOTOXY(2,1);
	i=0;
	while (i<strlen(missatge)) {
		DADA_LCD(missatge[i]);
		i++;
	}

     	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x08; // GO=1
	wsr=0x0; ad_command=regtemp;




/*  Bucle del programa principal  */
	
	while(1)
	{
	
	
	wsr=0x0; // Para leer ad_result
      	while (ad_result&0x08); // Esperar a que haya acabado (encuesta)


// while (1) {ioport1=bADEnCurs;} // probando

	wsr=0x00;

	if (bADEnCurs) { 
		//ioport1=wConversio;
	
		//  wConversio;	// 0 a 255  
		
		wConversio=wConversio&0xFF;
	       	porcent=(wConversio*100)/255;
		porcent=porcent&0xFF;

		
		missatge[0]= (porcent/100) %10 +'0';
		missatge[1]= (porcent/10)  %10 +'0';
		missatge[2]= (porcent/1)   %10 +'0';
		missatge[3]='%';
	
		GOTOXY(6,2);	// Segunda lnea
		i=0;
		while (i<=3) {
			DADA_LCD(missatge[i]);
			++i;
		}
		
	wsr=0xf; regtemp=ad_command;
	regtemp = regtemp | 0x08; // GO=1
	wsr=0x0; ad_command=regtemp;

		
	}
}

}


void RSIExtInt()
{
	asm {di;}
	bADEnCurs=!bADEnCurs;
	asm {ei;}
}
 

void RSIADDone()
{
	asm {di;}
	
	wsr=0x0; regtemp=ad_result;
	wConversio=regtemp>>8;
	regtemp = regtemp & 0xF7; // Desactivar el bit de aviso
	wsr=0xf; ad_result=regtemp;
  
	asm {ei;}
}

